%define name	trilinos
%define version 6.0.17
%define release %mkrel 4

%define	libaztecoo_major	3.4
%define	libaztecoo_name		%mklibname aztecoo %{libaztecoo_major}

%define	libepetra_major		3.4
%define	libepetra_name		%mklibname epetra %{libepetra_major}

%define	libepetraext_major	3.4
%define	libepetraext_name	%mklibname epetraext %{libepetraext_major}

%define	libifpack_major		3.0
%define	libifpack_name		%mklibname ifpack %{libifpack_major}

%define	libml_major		4.0
%define	libml_name		%mklibname ml %{libml_major}

%define	libnox_major		4.1
%define	libnox_name		%mklibname nox %{libnox_major}

%define	libteuchos_major	1.2
%define	libteuchos_name		%mklibname teuchos %{libteuchos_major}

%define	libtriutils_major	1.2
%define	libtriutils_name	%mklibname triutils %{libtriutils_major}

%if %{mdkversion} <= 1020
%define f77	g77
%else
%define f77	gfortran
%endif

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	Parallel solver algorithms and libraries 
License:	LGPL
Group:		System/Libraries
URL:		http://software.sandia.gov/trilinos/
Source:		http://software.sandia.gov/trilinos/%{name}-%{version}.tar.bz2
Patch0:		%{name}-6.0.15.export.patch.bz2
Patch1:		%{name}-6.0.15.libtool.patch.bz2
%if %{mdkversion} <= 1020
BuildRequires:	gcc-g77
%else
BuildRequires:	gcc-gfortran
%endif
BuildRequires:	automake1.8
BuildRequires:	lapack-devel
BuildRequires:	mpich2-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}

%description
The Trilinos Project is an effort to develop parallel so
libraries within an object-oriented so
large-scale, complex multi-physics engineering and scientific applications. A
unique design feature of Trilinos is its focus on packages.

%package -n %{libaztecoo_name}
Summary:	Main library for aztecoo
Group:		System/Libraries

%description -n %{libaztecoo_name}
AztecOO provides an object-oriented interface the the well-known Aztec so
library. Furthermore, it allows flexible construction of matrix and vector
arguments via Epetra matrix and vector classes. Finally, AztecOO provide
additional functionality not found in Aztec and any future enhancements to the
Aztec package will be available only through the AztecOO interfaces. 

%package -n %{libaztecoo_name}-devel
Summary:	Headers for developing programs that will use aztecoo
Group:		Development/Other
Requires:	%{libaztecoo_name} = %{version}
Provides:	aztecoo-devel = %{version}-%{release}
Provides:	libaztecoo-devel = %{version}-%{release}

%description -n %{libaztecoo_name}-devel
This package contains the headers that programmers will need to develop
applications which will use aztecoo.

%package -n %{libepetra_name}
Summary:	Main library for epetra
Group:		System/Libraries

%description -n %{libepetra_name}
Epetra provides the fundamental construction routines and services function
that are required for serial and parallel linear algebra libraries. Epetra
provides the underlying foundation for all Trilinos so

%package -n %{libepetra_name}-devel
Summary:	Headers for developing programs that will use epetra
Group:		Development/Other
Requires:	%{libepetra_name} = %{version}
Provides:	epetra-devel = %{version}-%{release}
Provides:	libepetra-devel = %{version}-%{release}

%description -n %{libepetra_name}-devel
This package contains the headers that programmers will need to develop
applications which will use epetra.

%package -n %{libepetraext_name}
Summary:	Main library for epetraext
Group:		System/Libraries

%description -n %{libepetraext_name}
EpetraExt provides the fundamental construction routines and services function
that are required for serial and parallel linear algebra libraries. EpetraExt
provides the underlying foundation for all Trilinos so

%package -n %{libepetraext_name}-devel
Summary:	Headers for developing programs that will use epetraext
Group:		Development/Other
Requires:	%{libepetraext_name} = %{version}
Provides:	epetraext-devel = %{version}-%{release}
Provides:	libepetraext-devel = %{version}-%{release}

%description -n %{libepetraext_name}-devel
This package contains the headers that programmers will need to develop
applications which will use epetraext.

%package -n %{libifpack_name}
Summary:	Main library for ifpack
Group:		System/Libraries

%description -n %{libifpack_name}
IFPACK provides a suite of object-oriented algebraic preconditioners for the
solution of preconditioned iterative solvers. IFPACK constructors expect an
Epetra_RowMatrix object for construction. IFPACK is part of the Trilinos Solver
Project and IFPACK object interact well with other Trilinos classes. In
particular, IFPACK can be used as a preconditioner for AztecOO.

%package -n %{libifpack_name}-devel
Summary:	Headers for developing programs that will use ifpack
Group:		Development/Other
Requires:	%{libifpack_name} = %{version}
Provides:	ifpack-devel = %{version}-%{release}
Provides:	libifpack-devel = %{version}-%{release}

%description -n %{libifpack_name}-devel
This package contains the headers that programmers will need to develop
applications which will use ifpack.

%package -n %{libml_name}
Summary:	Main library for ml
Group:		System/Libraries

%description -n %{libml_name}
ML is Sandia's main multigrid preconditioning package. ML is designed to so
arising primarily from elliptic PDE discretizations.

%package -n %{libml_name}-devel
Summary:	Headers for developing programs that will use ml
Group:		Development/Other
Requires:	%{libml_name} = %{version}
Provides:	ml-devel = %{version}-%{release}
Provides:	libml-devel = %{version}-%{release}

%description -n %{libml_name}-devel
This package contains the headers that programmers will need to develop
applications which will use ml.

%package -n %{libnox_name}
Summary:	Main library for nox
Group:		System/Libraries

%description -n %{libnox_name}
NOX is short for Nonlinear Object-Oriented Solutions, and its objective is to
enable the efficient solution of the equation: , where . NOX is designed to
work with any linear algebra package and to be easily customized. NOX is part
of Sandia's Trilinos project.

LOCA, distributed as part of NOX, is short for Library of Continuation
Algorithms, and its objective is to compute families of solutions to and their
bifurcations.

%package -n %{libnox_name}-devel
Summary:	Headers for developing programs that will use nox
Group:		Development/Other
Requires:	%{libnox_name} = %{version}
Provides:	nox-devel = %{version}-%{release}
Provides:	libnox-devel = %{version}-%{release}

%description -n %{libnox_name}-devel
This package contains the headers that programmers will need to develop
applications which will use nox.

%package -n teuchos
Summary:	The Trilinos Tools Library
Group:		System/Libraries

%description -n teuchos
Teuchos provides a suite of common tools for Trilinos for developers to use.
These tools include BLAS/LAPACK wrappers, smart pointers, parameter lists, XML
parsers, etc.

%package -n %{libteuchos_name}
Summary:	Main library for teuchos
Group:		System/Libraries

%description -n %{libteuchos_name}
Teuchos provides a suite of common tools for Trilinos for developers to use.
These tools include BLAS/LAPACK wrappers, smart pointers, parameter lists, XML
parsers, etc.

%package -n %{libteuchos_name}-devel
Summary:	Headers for developing programs that will use teuchos
Group:		Development/Other
Requires:	%{libteuchos_name} = %{version}
Provides:	teuchos-devel = %{version}-%{release}
Provides:	libteuchos-devel = %{version}-%{release}

%description -n %{libteuchos_name}-devel
This package contains the headers that programmers will need to develop
applications which will use teuchos.

%package -n %{libtriutils_name}
Summary:	Main library for triutils
Group:		System/Libraries

%description -n %{libtriutils_name}
TriUtils a package of utilities for other Trilinos packages.

%package -n %{libtriutils_name}-devel
Summary:	Headers for developing programs that will use triutils
Group:		Development/Other
Requires:	%{libtriutils_name} = %{version}
Provides:	triutils-devel = %{version}-%{release}
Provides:	libtriutils-devel = %{version}-%{release}

%description -n %{libtriutils_name}-devel
This package contains the headers that programmers will need to develop
applications which will use triutils.

%prep
%setup -q
%patch0 -p 1 -b .export
%patch1 -p 1 -b .libtool
chmod 644 packages/ml/COPYRIGHT

%build
aclocal-1.8 -I config
automake
autoconf-2.5x
for package in packages/*; do
   if [ -d $package ]; then
	pushd $package
	libtoolize
	aclocal-1.8 -I config
	automake
	autoconf-2.5x
	popd
    fi
done
%configure \
    --enable-mpi \
    --with-mpi-libs='-lmpich -lpmpich -lrt' \
    --disable-new_package \
    --disable-export-makefiles \
    --with-cxxflags="-DMPICH_IGNORE_CXX_SEEK" \
    F77=%{f77}
%make

%install
rm -rf %{buildroot}
%makeinstall_std
chmod 644 %{buildroot}%{_libdir}/*.la

%clean
rm -rf %{buildroot}

%post -n %{libaztecoo_name} -p /sbin/ldconfig

%postun -n %{libaztecoo_name} -p /sbin/ldconfig

%post -n %{libepetra_name} -p /sbin/ldconfig

%postun -n %{libepetra_name} -p /sbin/ldconfig

%post -n %{libepetraext_name} -p /sbin/ldconfig

%postun -n %{libepetraext_name} -p /sbin/ldconfig

%post -n %{libifpack_name} -p /sbin/ldconfig

%postun -n %{libifpack_name} -p /sbin/ldconfig

%post -n %{libml_name} -p /sbin/ldconfig

%postun -n %{libml_name} -p /sbin/ldconfig

%post -n %{libnox_name} -p /sbin/ldconfig

%postun -n %{libnox_name} -p /sbin/ldconfig

%post -n %{libteuchos_name} -p /sbin/ldconfig

%postun -n %{libteuchos_name} -p /sbin/ldconfig

%post -n %{libtriutils_name} -p /sbin/ldconfig

%postun -n %{libtriutils_name} -p /sbin/ldconfig

%files -n %{libaztecoo_name}
%defattr(-,root,root)
%{_libdir}/libaztecoo-%{libaztecoo_major}.so

%files -n %{libaztecoo_name}-devel
%defattr(-,root,root)
%doc packages/aztecoo/README
%{_includedir}/az_*
%{_includedir}/AztecOO*
%{_includedir}/AZOO_iterate.h
%{_includedir}/Aztec2Petra.h
%{_libdir}/libaztecoo.a
%{_libdir}/libaztecoo.la
%{_libdir}/libaztecoo.so

%files -n %{libepetra_name}
%defattr(-,root,root)
%{_libdir}/libepetra-%{libepetra_major}.so
%{_libdir}/libepetra_test-%{libepetra_major}.so

%files -n %{libepetra_name}-devel
%defattr(-,root,root)
%{_includedir}/Epetra_*
%{_libdir}/libepetra.a
%{_libdir}/libepetra.la
%{_libdir}/libepetra.so
%{_libdir}/libepetra_test.a
%{_libdir}/libepetra_test.la
%{_libdir}/libepetra_test.so

%files -n %{libepetraext_name}
%defattr(-,root,root)
%{_libdir}/libepetraext-%{libepetraext_major}.so

%files -n %{libepetraext_name}-devel
%defattr(-,root,root)
%{_includedir}/EpetraExt_*
%{_libdir}/libepetraext.a
%{_libdir}/libepetraext.la
%{_libdir}/libepetraext.so

%files -n %{libifpack_name}
%defattr(-,root,root)
%{_libdir}/libifpack-%{libifpack_major}.so

%files -n %{libifpack_name}-devel
%defattr(-,root,root)
%doc packages/ifpack/{ChangeLog-IFPACK,README-IFPACK}
%{_includedir}/Ifpack*
%{_includedir}/icrout_cholesky_mex.h
%{_includedir}/ifp_parameters.h
%{_libdir}/libifpack.a
%{_libdir}/libifpack.la
%{_libdir}/libifpack.so

%files -n %{libml_name}
%defattr(-,root,root)
%{_libdir}/libml-%{libml_major}.so

%files -n %{libml_name}-devel
%defattr(-,root,root)
%doc packages/ml/{README-ML,COPYRIGHT,ChangeLog-ML}
%{_includedir}/ml_*
%{_includedir}/MLAPI*
%{_includedir}/mli_solver.h
%{_libdir}/libml.a
%{_libdir}/libml.la
%{_libdir}/libml.so

%files -n %{libnox_name}
%defattr(-,root,root)
%{_libdir}/libnox-%{libnox_major}.so
%{_libdir}/libloca-%{libnox_major}.so

%files -n %{libnox_name}-devel
%defattr(-,root,root)
%doc packages/nox/{README,LICENSE}
%{_includedir}/NOX*
%{_includedir}/LOCA*
%{_libdir}/libnox.a
%{_libdir}/libnox.la
%{_libdir}/libnox.so
%{_libdir}/libloca.a
%{_libdir}/libloca.la
%{_libdir}/libloca.so

%files -n teuchos
%defattr(-,root,root)
%{_bindir}/*

%files -n %{libteuchos_name}
%defattr(-,root,root)
%{_libdir}/libteuchos-%{libteuchos_major}.so

%files -n %{libteuchos_name}-devel
%defattr(-,root,root)
%{_includedir}/Teuchos_*
%{_libdir}/libteuchos.a
%{_libdir}/libteuchos.la
%{_libdir}/libteuchos.so

%files -n %{libtriutils_name}
%defattr(-,root,root)
%{_libdir}/libtriutils-%{libtriutils_major}.so

%files -n %{libtriutils_name}-devel
%defattr(-,root,root)
%{_includedir}/Trilinos_Util*
%{_includedir}/Triutils_*
%{_includedir}/iohb.h
%{_libdir}/libtriutils.a
%{_libdir}/libtriutils.la
%{_libdir}/libtriutils.so


%changelog
* Fri Nov 17 2006 Guillaume Rousse <guillomovitch@mandriva.org> 6.0.17-4mdv2007.0
+ Revision: 85115
- rebuild against latest mpich2
- Import trilinos



* Thu Aug 31 2006 Guillaume Rousse <guillomovitch@mandriva.org> 6.0.17-3mdv2007.0
- Rebuild

* Mon May 22 2006 Guillaume Rousse <guillomovitch@mandriva.org> 6.0.17-2mdk
- use trilinos version for all subpackage, as individual versions doesn't change

* Thu May 18 2006 Guillaume Rousse <guillomovitch@mandriva.org> 6.0.17-1mdk
- new version
- enable MPI support

* Thu May 04 2006 Guillaume Rousse <guillomovitch@mandriva.org> 6.0.15-3mdk
- backportable before 2006.0

* Mon Mar 20 2006 Guillaume Rousse <guillomovitch@mandriva.org> 6.0.15-2mdk
- link each dynamic library against the ones it depends
- drop useless makefiles

* Wed Mar 15 2006 Guillaume Rousse <guillomovitch@mandriva.org> 6.0.15-1mdk
- first mdk release 
